<?php

define ( 'CC_MESSAGES', '' );
define ( 'CC_VERSION', '0.1' );
define ( 'CC_SESSION', 'CCsession' );
// If your wiki uses table prefixes, you must change this parameter:
define ( 'CC_TABLE_LOGS', 'cc_logs' );

global $wgAutoloadClasses;
global $wgSpecialPages;
global $CCIP;
global $wgScriptPath, $IP;
global $CCScriptPath;

$CCScriptPath = $wgScriptPath . '/extensions/ClickCounter';
$CCIP = $IP . '/extensions/ClickCounter';

$wgAutoloadClasses ['CCClickHandler'] = $CCIP . '/special/' . 'CC_ClickHandler.php';
$wgSpecialPages ['ClickHandler'] = 'CCClickHandler';

$wgAutoloadClasses ['CCCountSummary'] = $CCIP . '/special/' . 'CC_CountSummary.php';
$wgSpecialPages ['CountSummary'] = 'CCCountSummary';

/**
 * Message files
 */
global $wgExtensionMessagesFiles;
$wgExtensionMessagesFiles [CC_MESSAGES] = $CCIP . '/includes/' . 'CC_Messages.php';

global $wgExtensionCredits;
$wgExtensionCredits ['other'] [] = array ('name' => 'Click counter', 'version' => CC_VERSION, 'author' => 'Enrico Daga, STLab [CNR]', 'url' => 'http://www.mediawiki.org/wiki/Extension:ClickCounter', 'description' => 'Link counter adds features for counting user clicks.' );

include_once ('CC_ParserFunctions.php');

function ccfParserFunctionsLanguageGetMagic(&$magicWords, $langCode) {
	switch ($langCode) {
		default :
			$magicWords ['countit'] = array (0, 'countit' );
			$magicWords ['getcount'] = array (0, 'getcount' );
	}
	return true;
}

function ccSetupExtension() {
	
	// Setup parse function
	global $wgParser;
	global $CCParserFunctions;
	$CCParserFunctions = new CCParserFunctions ( );
	$wgParser->setFunctionHook ( 'countit', array (&$CCParserFunctions, 'run_countit' ) );
	$wgParser->setFunctionHook ( 'getcount', array (&$CCParserFunctions, 'run_getcount' ) );
	
	// Init session variable for caching the already counted links
	if ($_SESSION [CC_SESSION] == null) {
		$_SESSION [CC_SESSION] = array();
	}
}

$wgHooks ['LanguageGetMagic'] [] = 'ccfParserFunctionsLanguageGetMagic';
$wgExtensionFunctions [] = "ccSetupExtension";

function ccfSandboxParse($wikiText, $title = null) {
	global $wgTitle, $wgUser;
	if ($title == null)
		$title = $wgTitle;
	$myParser = new Parser ( );
	$myParserOptions = new ParserOptions ( );
	$myParserOptions->initialiseFromUser ( $wgUser );
	$result = $myParser->parse ( $wikiText, $title, $myParserOptions );
	return $result->getText ();
}
?>