<?php
/**
 * LinkHandler
 * @author Enrico Daga
 */

/**
 * Static launcher
 */
function ccfRunCCClickHandler() {
	CCClickHandler::run ();
}

class CCClickHandler extends SpecialPage {
	function CCClickHandler() {
		SpecialPage::SpecialPage ( "ClickHandler", '', true, 'ccfRunCCClickHandler' );
		wfLoadExtensionMessages ( CC_MESSAGES );
	}
	
	function run() {
		global $wgOut, $wgUser;
		global $wgRequest;
		
		$link = $wgRequest->getVal ( 'link' );
		$from_page_id = $wgRequest->getVal ( 'from_page_id' );
		$message = $wgRequest->getVal ( 'message' );
		
		if ($link == null)
			return;
		
		if (CCClickHandler::isExternal ( $link )) {
			CCClickHandler::registerLink ( $link, false , $from_page_id,$message);
			$wgOut->redirect ( $link );
			return;
		}
		if (CCClickHandler::isWiki ( $link )) {
			$pattern = "/^\\[\\[(.*)?\\|?\\]\\]/";
			$page = preg_replace ( $pattern, "$1", $link );
			CCClickHandler::registerLink ( $page, true ,$from_page_id,$message);
			global $wgArticlePath;
			$wgOut->redirect ( str_ireplace ( "$1", $page, $wgArticlePath ) );
			return;
		}
	}
	function registerLink($link, $internal = false , $from_page_id,$message) {
		if (in_array ( $link, $_SESSION [CC_SESSION] )) {
		} else {
			CCClickHandler::saveInDB ( $link, $internal , $from_page_id,$message );
			$_SESSION [CC_SESSION] [] = $link;
		}
	}
	private function saveInDB($link, $internal, $from_page_id,$log_message) {
		$db = wfGetDB ( DB_MASTER );
		global $wgUser;
		
		$ip=$_SERVER['REMOTE_ADDR']; 
		$username = $wgUser->getName();
		$timestamp = $db->timestamp();
		
		// Inserts log
		$db->insert ( CC_TABLE_LOGS, 
		array (
			'ccl_ip' => $ip, 
			'ccl_username' => $username, 
			'ccl_link' => $link,
			'ccl_internal' => $internal,
			'ccl_from_page_id' => $from_page_id,
			'ccl_log_message' => $log_message, 
			'ccl_timestamp' => $timestamp ), 
		'CCClickHandler::saveInDB' 
		);
	
	}
	function isWiki($link) {
		$ismatch = preg_match ( "/^\\[\\[(.*)?\\]\\]/", $link );
		return ($ismatch == 1);
	}
	function isExternal($link) {
		$ismatch = preg_match ( "/^\\[?http:\\/\\//", $link );
		return ($ismatch == 1);
	}
}
?>